package name.Huchickut.SmallWorm;

import java.awt.*;
import java.awt.geom.AffineTransform;

public class Worm {

	private static Worm obj;
	private double[] posX;
	private double[] posY;
	private double speed;
	private double speedDef;
	private double richtung;
	private double kopfGr;
	private int laenge;
	private double abstand;
	private double lenkung;
	private int punkte;
	private int level;
	private double beschleunigung, bremsen;
	private boolean koerper;
	private double koerperrw;
	private static int[] bedarf = { 15, 20, 30, 40, 55, 72, 93, 119, 150, 185, 215};
	public int time;
	
	
	public Worm() {
		obj = this;
		posX = new double[2000];
		posY = new double[posX.length];
		for (int i = 0; i < posX.length; i++) {
			posX[i] = -100;
			posY[i] = -100;
		}
		posX[0] = 400;
		posY[0] = 300;

		richtung = 10;
		punkte = 0;
		level = 0;
		speed = 2;
		speedDef = speed;
		kopfGr = 30;
		laenge = 5;
		lenkung = 1.5;
		beschleunigung = speed;
		bremsen = speed;
		koerper = false;
		koerperrw = 0;
		time= 0;
		abstand = 0.8 * kopfGr / speedDef;
	}

	public static Worm get() {
		return obj;
	}

	public void changelenkung(int wert) {
		lenkung += wert;
	}

	public void changelaenge(int wert) {
		laenge += wert;
	}

	public void changekopfGr(int wert) {
		kopfGr += wert;
		abstand = 0.8 * kopfGr / speedDef;

	}

	public void changespeed(double wert) {
		speedDef += wert;
		beschleunigung += wert;
		bremsen += wert;
		abstand = 0.8 * kopfGr / speedDef;
	}

	public void changebeschleunigung(double wert) {
		beschleunigung = speedDef + wert;
	}

	public void changebremsen(double wert) {
		bremsen = speedDef- wert;
		if(bremsen < 0.5) {
			bremsen = 0.5;
		}
	}

	public void changekoerper(int wert) {
		koerper = true;
		koerperrw += wert;
	}

	public int gibPunkte() {
		return punkte;
	}

	public int gibLevel() {
		return level;
	}

	public int gibTime() {
		return time;
	}
	
	public boolean kollision(double x, double y, int wert) {

		if (Math.sqrt((x - posX[0]) * (x - posX[0]) + (y - posY[0])
				* (y - posY[0]))
				- kopfGr / 2 - 8 <= 0) {
			punkte += wert;
			return true;
		}
		if (koerper) {
			for (int i = 1; i < laenge; i++) {

				if (Math.sqrt((x - posX[(int) (i * abstand)])
						* (x - posX[(int) (i * abstand)])
						+ (y - posY[(int) (i * abstand)])
						* (y - posY[(int) (i * abstand)]))
						- kopfGr / 2 - 8 <= koerperrw) {
					punkte += wert;
					return true;
				}
			}
		}
		return false;
	}

	public double nextLevel() {
		if (level != bedarf.length - 1) {
			level++;
		} else {
			Spiel.get().spielende();
		}
		punkte -= bedarf[level - 1];
		Spiel.get().evolution();
		return bedarf[level];
	}

	public void zeichne(Graphics2D g) {
		g.setColor(new Color(0, 0, 0));

		for (int i = 1; i < laenge; i++) {
			g.fillOval((int) (posX[(int) (i * abstand)] - kopfGr / 2),
					(int) (posY[(int) (i * abstand)] - kopfGr / 2),
					(int) kopfGr, (int) kopfGr);
		}
		AffineTransform t = g.getTransform();
		g.rotate(-1*Math.toRadians(richtung), posX[0],posY[0]);
		g.drawImage(Images.head, (int)(posX[0] - kopfGr / 2),(int) (posY[0] - kopfGr / 2),(int) kopfGr,(int) kopfGr, null);
		g.setTransform(t);
	}

	public void tick() {
		for (int i = posX.length - 2; i >= 0; i--) {
			posX[i + 1] = posX[i];
			posY[i + 1] = posY[i];
		}
		posX[0] += speed * Math.cos(Math.toRadians(richtung));
		posY[0] += speed * Math.sin(Math.toRadians(richtung)) * -1;
		if (posX[0] >= 800  + 25) {
			posX[0] = 0  ;
		}
		if (posX[0] <= 0   - 25) {
			posX[0] = 800   ;
		}
		if (posY[0] >= 500  + 25) {
			posY[0] = 0  ;
		}
		if (posY[0] <= 0 - 25) {
			posY[0] = 500 ;
		}
		if (ZF.keys[6]) {
			richtung -= lenkung;
		}
		if (ZF.keys[8]) {
			richtung += lenkung;
		}
		if (speed < beschleunigung && ZF.keys[5]) {
			speed += 0.1;
		} else if (speed > speedDef) {
			speed -= 0.1;
		}
		if (speed > bremsen && ZF.keys[7]) {
			speed -= 0.1;
		} else if (speed < speedDef) {
			speed += 0.1;
		}
		time++;
	}
}
